; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_HAUPTMENUE:

; LCD_SONDERZEICHEN_PROGRAMMIEREN_1	
	rcall LCD_SONDERZEICHEN_PROGRAMMIEREN_1		; BALKEN BETRIEBSSPANNUNG			
; LCD_SONDERZEICHEN_PROGRAMMIEREN_2	
	rcall LCD_SONDERZEICHEN_PROGRAMMIEREN_2		; BALKEN ANZ SATELLITEN gesamt		
; LCD_SONDERZEICHEN_PROGRAMMIEREN_3	
	rcall LCD_SONDERZEICHEN_PROGRAMMIEREN_3		; BALKEN ANZ SATELLITEN emfangen	
; LCD_SONDERZEICHEN_PROGRAMMIEREN_6
	rcall LCD_SONDERZEICHEN_PROGRAMMIEREN_6		; BALKEN PEGEL						

; LCD GOHOME						
	rcall LCD_GO_HOME

; ENTFERNUNG						
	rcall FUNKTION_TEMP1_9_CLEAR 			; OUT: TEMP1...9 (alle 0)				
	LDS temp1,(adr_GPS_ENTFERNUNG_BYTE_1)	; aus SRAM laden
	LDS temp2,(adr_GPS_ENTFERNUNG_BYTE_2)	; aus SRAM laden
	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_FORMAT						; INPUT: TEMP1...TEMP9			 	
	rcall LCD_AUSGABE_ZAHL_6_STELLEN_KURZ	; INP: TEMP1...6				  

; MASSEINHEIT Entfernung m/km	
	ldi temp1,'m'
	ldi temp2,' '
	LDS temp,(adr_GPS_ENTFERNUNG_in_km)	; aus SRAM laden
	tst temp
	breq ANZEIGE_HAUPTMENUE_EINHEIT_ENTFERNUNG
	ldi temp1,'k'
	ldi temp2,'m'
ANZEIGE_HAUPTMENUE_EINHEIT_ENTFERNUNG:
	mov temp, temp1
	rcall LCD_DATA
	mov temp, temp2
	rcall LCD_DATA

	rcall LCD_SPACE							; SPACE	
	rcall LCD_SPACE							; SPACE	
; HHE							
	rcall ANZEIGE_HOEHE_BERECHNET_KURZ

; 2. ZEILE																				
	rcall LCD_ZEILE2

; A/V ZUSTAND						
	LDS temp,(adr_GPS_AKTIV)				; aus SRAM holen	
	rcall LCD_DATA							; DATENBYTE an LCD inp: temp 				  

; BALKEN-Betriebsspannung		
	ldi temp, 1				; SONDERZEICHEN 1
	rcall LCD_DATA
; BALKEN-ANZAHL Satelliten	(gesamt)
	ldi temp, 2				; Sonderzeichen 2
	rcall LCD_DATA
; BALKEN ANZAHL Satelliten	
	ldi temp, 3				; Sonderzeichen 3
	rcall LCD_DATA
; BALKEN PEGEL				
	ldi temp, 6				; Sonderzeichen 6
	rcall LCD_DATA


; GESCHWINDIGKEIT			
	rcall ANZEIGE_GESCHWINDIGKEIT_KURZ
	

	rcall LCD_SPACE							; SPACE	

; KURS				
	rcall FUNKTION_TEMP1_9_CLEAR 			; OUT: TEMP1...9 (alle 0)				
	LDS temp1,(adr_GPS_KURS_L)
	LDS temp2,(adr_GPS_KURS_H)
	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_FORMAT						; INPUT: TEMP1...TEMP9			 	
	rcall LCD_AUSGABE_ZAHL_3_STELLEN_KURZ

	ldi temp,0				; SYMBOL ""			
	rcall LCD_DATA
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_HOEHE_BERECHNET_KURZ:
	rcall FUNKTION_TEMP1_9_CLEAR 			; OUT: TEMP1...9 (alle 0)				
	LDS temp1,(adr_GPS_HOEHE_BERECHNET_L)
	LDS temp2,(adr_GPS_HOEHE_BERECHNET_H)
	; ZAHL negativ ?		
	tst temp2
	brpl ANZEIGE_HOEHE_BERECHNET_KURZ_POSITIV
	; ZAHL ist negativ		
	ldi temp, '-'	
	rcall LCD_DATA
	com temp1
	com temp2
	ldi temp3,1
	clr temp4
	add temp1,temp3
	adc temp2,temp4
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_AUSGABE_ZAHL_4_STELLEN_KURZ
	ldi temp, 'm'
	rcall LCD_DATA
	ret
	; ZAHL ist positiv		
ANZEIGE_HOEHE_BERECHNET_KURZ_POSITIV:
	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_FORMAT						; INPUT: TEMP1...TEMP9			 	
	rcall LCD_AUSGABE_ZAHL_5_STELLEN_KURZ	; INP: TEMP1...5				  
	ldi temp, 'm'
	rcall LCD_DATA
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ALLE_PEGEL:
	rcall LCD_CLEAR
	; initialisieren ZEIGER
	ldi XL,low (adr_GPS_PEGEL_1_1)
	ldi XH,high(adr_GPS_PEGEL_1_1)

	rcall ANZEIGE_ALLE_PEGEL_KURZ ; PEGEL_1_1
	rcall ANZEIGE_ALLE_PEGEL_KURZ ; PEGEL_1_2
	rcall ANZEIGE_ALLE_PEGEL_KURZ ; PEGEL_1_3
	rcall ANZEIGE_ALLE_PEGEL_KURZ ; PEGEL_1_4

 	rcall ANZEIGE_ALLE_PEGEL_KURZ ; PEGEL_2_1
	rcall ANZEIGE_ALLE_PEGEL_KURZ ; PEGEL_2_2



	rcall LCD_ZEILE2

	rcall ANZEIGE_ALLE_PEGEL_KURZ ; PEGEL_2_3
	rcall ANZEIGE_ALLE_PEGEL_KURZ ; PEGEL_2_4

	rcall ANZEIGE_ALLE_PEGEL_KURZ ; PEGEL_3_1
	rcall ANZEIGE_ALLE_PEGEL_KURZ ; PEGEL_3_2
	rcall ANZEIGE_ALLE_PEGEL_KURZ ; PEGEL_3_3
	rcall ANZEIGE_ALLE_PEGEL_KURZ ; PEGEL_3_4

ret

ANZEIGE_ALLE_PEGEL_KURZ:
	rcall FUNKTION_TEMP1_9_CLEAR 				; OUT: TEMP1...9 (alle 0)				
	LD temp1, X+								; laden und X+1		
	rcall FUNKTION_HEX_ASC_32					; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_FORMAT							; INPUT: TEMP1...TEMP9			 	
	rcall LCD_AUSGABE_ZAHL_2_STELLEN_KURZ		; INP: TEMP1...6				  
	rcall LCD_PUNKT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_X_Y_DIFFERENZ:
	rcall LCD_CLEAR

	ldi temp, 'X'				; X
	rcall LCD_DATA	
	rcall LCD_SPACE

	rcall FUNKTION_TEMP1_9_CLEAR 				; OUT: TEMP1...9 (alle 0)				
	LDS temp1,(adr_X_LAENGE_DIFFERENZ_BYTE1)	; aus SRAM laden	
	LDS temp2,(adr_X_LAENGE_DIFFERENZ_BYTE2)	; aus SRAM laden	
	rcall FUNKTION_HEX_ASC_32					; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_AUSGABE_ZAHL_5_STELLEN_KURZ		; INP: TEMP1...5				  

	rcall LCD_ZEILE2

	ldi temp, 'Y'				; Y

	rcall LCD_DATA	
	rcall LCD_SPACE

	rcall FUNKTION_TEMP1_9_CLEAR 				; OUT: TEMP1...9 (alle 0)				
	LDS temp1,(adr_Y_BREITE_DIFFERENZ_BYTE1)	; aus SRAM laden	
	LDS temp2,(adr_Y_BREITE_DIFFERENZ_BYTE2)	; aus SRAM laden	
	rcall FUNKTION_HEX_ASC_32					; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_AUSGABE_ZAHL_5_STELLEN_KURZ		; INP: TEMP1...5				  

	rcall LCD_SPACE

	rcall FUNKTION_TEMP1_9_CLEAR 				; OUT: TEMP1...9 (alle 0)				
	LDS temp1,(adr_GPS_ENTFERNUNG_BYTE_1)		; aus SRAM laden	
	LDS temp2,(adr_GPS_ENTFERNUNG_BYTE_2)		; aus SRAM laden	
	rcall FUNKTION_HEX_ASC_32					; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_AUSGABE_ZAHL_5_STELLEN_KURZ		; INP: TEMP1...5				  


ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_REFERENZ_GELADEN_INFO_NAME:
	rcall LCD_CLEAR

	ldi ZH, high(TEXT_AKTIVE_REFERENZ*2)	; TEXT "aktive Referenz"
	ldi ZL, low (TEXT_AKTIVE_REFERENZ*2)
	rcall ANZEIGE_TEXT
	
	rcall LCD_ZEILE2

	mov temp, REFERENZ_NUMMER			; A(EEPROM),B(EEPROM),C(EEPROM),1,2,3,4,5,6,7,8,9,10...
	rcall ANZEIGE_REFERENZ_NAME_KURZ	; INP: TEMP (REFERENZ_NUMMER=> A(EEPROM),B(EEPROM),C(EEPROM),1,2,3,4,5,6,7,8,9,10...)

ret

; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_GESCHWINDIGKEIT_KURZ:
	rcall FUNKTION_TEMP1_9_CLEAR 			; OUT: TEMP1...9 (alle 0)					
	LDS temp1,(adr_GPS_GESCHWINDIGKEIT_L)
	LDS temp2,(adr_GPS_GESCHWINDIGKEIT_H)
	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_FORMAT						; INPUT: TEMP1...TEMP9			 	
	rcall LCD_AUSGABE_ZAHL_5_STELLEN_KURZ	; INP: TEMP1...5				  
	; SONDERZEICHEN				
	LDS temp1,(adr_GPS_GESCHWINDIGKEIT_L)
	LDS temp2,(adr_GPS_GESCHWINDIGKEIT_H)
	add temp1,temp2
	tst temp1
	brne ANZEIGE_GESCHWINDIGKEIT_KURZ_w
	ldi temp, '_'							; "_"
	rcall LCD_DATA
	ret
ANZEIGE_GESCHWINDIGKEIT_KURZ_w:
	ldi temp, 4								; Sonderzeichen 4
	rcall LCD_DATA
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_UTC_ZEIT:
	rcall LCD_CLEAR
	ldi ZH, high(TEXT_UTC_ZEIT*2)	; TEXT "aktive Referenz"
	ldi ZL, low (TEXT_UTC_ZEIT*2)
	rcall ANZEIGE_TEXT	

	rcall LCD_ZEILE2

	; DATUM		
	LDS temp1,(adr_GPS_TAG)
	rcall ANZEIGE_2_STELLEN_HEX_ASC	; INP: TEMP1
	LDS temp1,(adr_GPS_MONAT)
	rcall ANZEIGE_2_STELLEN_HEX_ASC	; INP: TEMP1
	LDS temp1,(adr_GPS_JAHR)
	rcall ANZEIGE_2_STELLEN_HEX_ASC	; INP: TEMP1

	rcall LCD_SPACE	
	rcall LCD_SPACE	

	; ZEIT
	LDS temp1,(adr_GPS_hh)
	rcall ANZEIGE_2_STELLEN_HEX_ASC	; INP: TEMP1
	rcall LCD_DOPPEL_PUNKT			; ":"
	LDS temp1,(adr_GPS_mm)
	rcall ANZEIGE_2_STELLEN_HEX_ASC	; INP: TEMP1
	rcall LCD_DOPPEL_PUNKT			; ":"
	LDS temp1,(adr_GPS_ss)
	rcall ANZEIGE_2_STELLEN_HEX_ASC	; INP: TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ONLINE_OFFLINE:
	rcall LCD_CLEAR
	; ONLINE	
	LDS temp1,(adr_GPS_ONLINE_hh)
	rcall ANZEIGE_2_STELLEN_HEX_ASC	; INP: TEMP1
	rcall LCD_DOPPEL_PUNKT			; ":"
	LDS temp1,(adr_GPS_ONLINE_mm)
	rcall ANZEIGE_2_STELLEN_HEX_ASC	; INP: TEMP1
	rcall LCD_DOPPEL_PUNKT			; ":"
	LDS temp1,(adr_GPS_ONLINE_ss)
	rcall ANZEIGE_2_STELLEN_HEX_ASC	; INP: TEMP1

	rcall LCD_ZEILE2

	; OFFLINE	
	LDS temp1,(adr_GPS_OFFLINE_hh)
	rcall ANZEIGE_2_STELLEN_HEX_ASC	; INP: TEMP1
	rcall LCD_DOPPEL_PUNKT			; ":"
	LDS temp1,(adr_GPS_OFFLINE_mm)
	rcall ANZEIGE_2_STELLEN_HEX_ASC	; INP: TEMP1
	rcall LCD_DOPPEL_PUNKT			; ":"
	LDS temp1,(adr_GPS_OFFLINE_ss)
	rcall ANZEIGE_2_STELLEN_HEX_ASC	; INP: TEMP1

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_BETRIEBSSTUNDEN:
	rcall LCD_CLEAR
	ldi ZH, high(TEXT_BETRIEBSSTUNDEN*2)	; TEXT "aktive Referenz"
	ldi ZL, low (TEXT_BETRIEBSSTUNDEN*2)
	rcall ANZEIGE_TEXT	

	rcall LCD_ZEILE2

	; ZEIT
	LDS temp1,(adr_BETRIEBSSTUNDEN_hh)
	rcall ANZEIGE_3_STELLEN_HEX_ASC			; INP: TEMP1
	rcall LCD_DOPPEL_PUNKT			; ":"
	LDS temp1,(adr_BETRIEBSSTUNDEN_mm)
	rcall ANZEIGE_2_STELLEN_HEX_ASC			; INP: TEMP1
	rcall LCD_DOPPEL_PUNKT			; ":"
	LDS temp1,(adr_BETRIEBSSTUNDEN_ss)
	rcall ANZEIGE_2_STELLEN_HEX_ASC			; INP: TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_SPANNUNG_TEMPERATUR:
	rcall LCD_CLEAR					; clear

	ldi ZH, high(TEXT_SPANNUNG*2)	; TEXT 
	ldi ZL,  low(TEXT_SPANNUNG*2)
	rcall ANZEIGE_TEXT

	rcall FUNKTION_TEMP1_9_CLEAR	; OUT: TEMP1...9 (alle 0)				
	LDS temp1,(adr_SPANNUNG_L)
	LDS temp2,(adr_SPANNUNG_H)
	rcall FUNKTION_HEX_ASC_32		; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_FORMAT				; INPUT: TEMP1...TEMP9			 	
	rcall LCD_AUSGABE_ZAHL_7_STELLEN_KURZ
	ldi temp, 'V'					; V 
	rcall LCD_DATA


	rcall LCD_ZEILE2

	ldi ZH, high(TEXT_TEMPERATUR*2)	; TEXT 
	ldi ZL,  low(TEXT_TEMPERATUR*2)
	rcall ANZEIGE_TEXT

	rcall FUNKTION_TEMP1_9_CLEAR	; OUT: TEMP1...9 (alle 0)				
	LDS temp1, adr_TEMPERATUR_L		; aus SRAM laden
	LDS temp2, adr_TEMPERATUR_H		; aus SRAM laden
	rcall FUNKTION_HEX_ASC_32		; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_FORMAT				; INPUT: TEMP1...TEMP9			 	
	rcall LCD_AUSGABE_ZAHL_3_STELLEN_KURZ
	ldi temp,0						; ""			
	rcall LCD_DATA
	ldi temp, 'C'					; C 								
	rcall LCD_DATA
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ROT_INVERIEREN:
	rcall LCD_CLEAR
	ldi ZH, high(TEXT_LED_ROT_INVERTIEREN*2)	; TEXT 
	ldi ZL,  low(TEXT_LED_ROT_INVERTIEREN*2)
	rcall ANZEIGE_TEXT

	rcall LCD_ZEILE2

	rcall FUNKTION_TEMP1_9_CLEAR	; OUT: TEMP1...9 (alle 0)				
	LDS temp1, (adr_LED_ROT_INVERTIEREN); aus SRAM laden
	rcall FUNKTION_HEX_ASC_32		; INPUT: temp1...4 OUTPUT: Temp1...8			
	mov temp, temp1			
	rcall LCD_DATA
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_MCUCSR:
	rcall LCD_CLEAR

	ldi ZH, high(TEXT_MCUCSR*2)	; TEXT "aktive Referenz"
	ldi ZL, low (TEXT_MCUCSR*2)
	rcall ANZEIGE_TEXT	

	rcall LCD_ZEILE2

;	Bit 	7 	6 	5 	4 	3 		2 		1 		0		
;							WDRF 	BORF 	EXTRF 	PORF 	

	in  temp1, MCUCSR		; MCUCSR einlesen	
	LSR temp1				; 1 x rechts 		
	brcc ANZEIGE_MCUCSR_1	; kein C ==> SPRUNG 
	ldi temp, 'P'
	rcall LCD_DATA
	ldi temp, 'O'
	rcall LCD_DATA
	rcall LCD_SPACE
ANZEIGE_MCUCSR_1:
	LSR temp1				; 1 x rechts 		
	brcc ANZEIGE_MCUCSR_2	; kein C ==> SPRUNG 
	ldi temp, 'E'
	rcall LCD_DATA
	ldi temp, 'X'
	rcall LCD_DATA
	ldi temp, 'T'
	rcall LCD_DATA
	rcall LCD_SPACE
ANZEIGE_MCUCSR_2:
	LSR temp1				; 1 x rechts 		
	brcc ANZEIGE_MCUCSR_3	; kein C ==> SPRUNG 
	ldi temp, 'B'
	rcall LCD_DATA
	ldi temp, 'O'
	rcall LCD_DATA
	rcall LCD_SPACE
ANZEIGE_MCUCSR_3:
	LSR temp1				; 1 x rechts 		
	brcc ANZEIGE_MCUCSR_4	; kein C ==> SPRUNG 
	ldi temp, 'W'
	rcall LCD_DATA
	ldi temp, 'D'
	rcall LCD_DATA
ANZEIGE_MCUCSR_4:
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; INPUT: TEMP (REFERENZ_NUMMER=> A(EEPROM),B(EEPROM),C(EEPROM),1,2,3,4,5,6,7,8,9,10...)
;																				
; rcall ANZEIGE_REFERENZ_NAME_KURZ	; INP: TEMP (REFERENZ_NUMMER=> A(EEPROM),B(EEPROM),C(EEPROM),1,2,3,4,5,6,7,8,9,10...)
;																				
ANZEIGE_REFERENZ_NAME_KURZ:
	cpi temp, 'A'
	brne ANZEIGE_REFERENZ_NAME_KURZ_wB
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_A
ANZEIGE_REFERENZ_NAME_KURZ_wB:
	cpi temp, 'B'
	brne ANZEIGE_REFERENZ_NAME_KURZ_wC
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_B
ANZEIGE_REFERENZ_NAME_KURZ_wC:
	cpi temp, 'C'
	brne ANZEIGE_REFERENZ_NAME_KURZ_w1
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_C
ANZEIGE_REFERENZ_NAME_KURZ_w1:
	cpi temp, 1
	brne ANZEIGE_REFERENZ_NAME_KURZ_w2
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_01
ANZEIGE_REFERENZ_NAME_KURZ_w2:
	cpi temp, 2
	brne ANZEIGE_REFERENZ_NAME_KURZ_w3
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_02
ANZEIGE_REFERENZ_NAME_KURZ_w3:
	cpi temp, 3
	brne ANZEIGE_REFERENZ_NAME_KURZ_w4
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_03
ANZEIGE_REFERENZ_NAME_KURZ_w4:
	cpi temp, 4
	brne ANZEIGE_REFERENZ_NAME_KURZ_w5
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_04
ANZEIGE_REFERENZ_NAME_KURZ_w5:
	cpi temp, 5
	brne ANZEIGE_REFERENZ_NAME_KURZ_w6
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_05
ANZEIGE_REFERENZ_NAME_KURZ_w6:
	cpi temp, 6
	brne ANZEIGE_REFERENZ_NAME_KURZ_w7
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_06
ANZEIGE_REFERENZ_NAME_KURZ_w7:
	cpi temp, 7
	brne ANZEIGE_REFERENZ_NAME_KURZ_w8
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_07
ANZEIGE_REFERENZ_NAME_KURZ_w8:
	cpi temp, 8
	brne ANZEIGE_REFERENZ_NAME_KURZ_w9
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_08
ANZEIGE_REFERENZ_NAME_KURZ_w9:
	cpi temp, 9
	brne ANZEIGE_REFERENZ_NAME_KURZ_w10
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_09
ANZEIGE_REFERENZ_NAME_KURZ_w10:
	cpi temp, 10
	brne ANZEIGE_REFERENZ_NAME_KURZ_w11
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_10
ANZEIGE_REFERENZ_NAME_KURZ_w11:
	cpi temp, 11
	brne ANZEIGE_REFERENZ_NAME_KURZ_w12
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_11
ANZEIGE_REFERENZ_NAME_KURZ_w12:
	; ERROR	
	ldi ZH, high(TEXT_ERROR*2)			; ERROR
	ldi ZL, low (TEXT_ERROR*2)
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_FERTIG




ANZEIGE_REFERENZ_NAME_KURZ_A:
	ldi ZH, high(TEXT_REFERENZ_A*2)		; EEPROM REFERENZ	A	
	ldi ZL, low (TEXT_REFERENZ_A*2)
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_FERTIG
ANZEIGE_REFERENZ_NAME_KURZ_B:
	ldi ZH, high(TEXT_REFERENZ_B*2)		; EEPROM REFERENZ	B	
	ldi ZL, low (TEXT_REFERENZ_B*2)
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_FERTIG
ANZEIGE_REFERENZ_NAME_KURZ_C:
	ldi ZH, high(TEXT_REFERENZ_C*2)		; EEPROM REFERENZ	C	
	ldi ZL, low (TEXT_REFERENZ_C*2)
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_FERTIG
ANZEIGE_REFERENZ_NAME_KURZ_01:
	ldi ZH, high(TEXT_REFERENZ_1*2)		; REFERENZ	1	
	ldi ZL, low (TEXT_REFERENZ_1*2)
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_FERTIG
ANZEIGE_REFERENZ_NAME_KURZ_02:
	ldi ZH, high(TEXT_REFERENZ_2*2)		; REFERENZ	2	
	ldi ZL, low (TEXT_REFERENZ_2*2)
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_FERTIG
ANZEIGE_REFERENZ_NAME_KURZ_03:
	ldi ZH, high(TEXT_REFERENZ_3*2)		; REFERENZ	3	
	ldi ZL, low (TEXT_REFERENZ_3*2)
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_FERTIG
ANZEIGE_REFERENZ_NAME_KURZ_04:
	ldi ZH, high(TEXT_REFERENZ_4*2)		; REFERENZ	4	
	ldi ZL, low (TEXT_REFERENZ_4*2)
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_FERTIG
ANZEIGE_REFERENZ_NAME_KURZ_05:
	ldi ZH, high(TEXT_REFERENZ_5*2)		; REFERENZ	5	
	ldi ZL, low (TEXT_REFERENZ_5*2)
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_FERTIG
ANZEIGE_REFERENZ_NAME_KURZ_06:
	ldi ZH, high(TEXT_REFERENZ_6*2)		; REFERENZ	6	
	ldi ZL, low (TEXT_REFERENZ_6*2)
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_FERTIG
ANZEIGE_REFERENZ_NAME_KURZ_07:
	ldi ZH, high(TEXT_REFERENZ_7*2)		; REFERENZ	7	
	ldi ZL, low (TEXT_REFERENZ_7*2)
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_FERTIG
ANZEIGE_REFERENZ_NAME_KURZ_08:
	ldi ZH, high(TEXT_REFERENZ_8*2)		; REFERENZ	8	
	ldi ZL, low (TEXT_REFERENZ_8*2)
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_FERTIG
ANZEIGE_REFERENZ_NAME_KURZ_09:
	ldi ZH, high(TEXT_REFERENZ_9*2)		; REFERENZ	9	
	ldi ZL, low (TEXT_REFERENZ_9*2)
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_FERTIG
ANZEIGE_REFERENZ_NAME_KURZ_10:
	ldi ZH, high(TEXT_REFERENZ_10*2)	; REFERENZ	10	
	ldi ZL, low (TEXT_REFERENZ_10*2)
	rjmp ANZEIGE_REFERENZ_NAME_KURZ_FERTIG
ANZEIGE_REFERENZ_NAME_KURZ_11:
	ldi ZH, high(TEXT_REFERENZ_11*2)	; REFERENZ	11	
	ldi ZL, low (TEXT_REFERENZ_11*2)
ANZEIGE_REFERENZ_NAME_KURZ_FERTIG:
	rcall ANZEIGE_TEXT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_REFERENZ_GELADEN_INFO_KOORDINATEN:
	rcall LCD_CLEAR

	LDS temp1,(adr_GPS_REFERENZ_X_LAENGE_BYTE1)
	LDS temp2,(adr_GPS_REFERENZ_X_LAENGE_BYTE2)
	LDS temp3,(adr_GPS_REFERENZ_X_LAENGE_BYTE3)
	LDS temp4,(adr_GPS_REFERENZ_X_LAENGE_BYTE4)
    rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_AUSGABE_ZAHL_8_STELLEN_KURZ	; INP: TEMP1...8

	rcall LCD_SPACE
	rcall ANZEIGE_TEXT_REFERENZ_KURZ

	rcall LCD_ZEILE2

	LDS temp1,(adr_GPS_REFERENZ_Y_BREITE_BYTE1)
	LDS temp2,(adr_GPS_REFERENZ_Y_BREITE_BYTE2)
	LDS temp3,(adr_GPS_REFERENZ_Y_BREITE_BYTE3)
	LDS temp4,(adr_GPS_REFERENZ_Y_BREITE_BYTE4)
    rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_AUSGABE_ZAHL_8_STELLEN_KURZ	; INP: TEMP1...8

	rcall LCD_SPACE

	LDS temp1,(adr_GPS_REFERENZ_HOEHE_L)
	LDS temp2,(adr_GPS_REFERENZ_HOEHE_H)
	clr temp3
	clr temp4
    rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_AUSGABE_ZAHL_3_STELLEN_KURZ
	ldi temp, 'm'							; m				
	rcall LCD_DATA
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ANZAHL_PROGRAMM_STARTS:
	rcall LCD_CLEAR

	ldi ZH, high(TEXT_PROGRAMMSTARTS*2)	; TEXT 
	ldi ZL, low (TEXT_PROGRAMMSTARTS*2)
	rcall ANZEIGE_TEXT

	rcall LCD_ZEILE2		

	rcall FUNKTION_TEMP1_9_CLEAR 		; OUT: TEMP1...9 (alle 0)				
	LDS temp1,(adr_ANZ_PROGRAMMSTARTS_L)	; aus SRAM laden	
	LDS temp2,(adr_ANZ_PROGRAMMSTARTS_H)
	rcall FUNKTION_HEX_ASC_32			; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_FORMAT					; INPUT: TEMP1...TEMP9			 	
	rcall LCD_AUSGABE_ZAHL_6_STELLEN_KURZ

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TEXT_NEUE_REFERENZ:
	rcall LCD_CLEAR
	ldi ZH, high(TEXT_NEUE_REFERENZ*2)	; TEXT 
	ldi ZL, low (TEXT_NEUE_REFERENZ*2)
	rcall ANZEIGE_TEXT

	rcall LCD_ZEILE2

	mov temp, REFERENZ_NUMMER			; A(EEPROM),B(EEPROM),C(EEPROM),1,2,3,4,5,6,7,8,9,10...
	rcall ANZEIGE_REFERENZ_NAME_KURZ	; INP: TEMP (REFERENZ_NUMMER=> A(EEPROM),B(EEPROM),C(EEPROM),1,2,3,4,5,6,7,8,9,10...)


ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;	"REFERENZ"		
;	"gespeichert"	
ANZEIGE_TEXT_GESPEICHERT:
	rcall LCD_CLEAR

	rcall ANZEIGE_TEXT_REFERENZ_KURZ

	rcall LCD_ZEILE2
	ldi ZH, high(TEXT_GESPEICHERT*2)	; TEXT 
	ldi ZL, low (TEXT_GESPEICHERT*2)
	rcall ANZEIGE_TEXT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;	"REFERENZ"		
ANZEIGE_TEXT_REFERENZ_KURZ:
	ldi ZH, high(TEXT_REFERENZ*2)		; TEXT 
	ldi ZL, low (TEXT_REFERENZ*2)
	rcall ANZEIGE_TEXT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_GPS_POSITION_AKTUELL_DEZIMAL:
	rcall LCD_CLEAR

	LDS temp1, (adr_GPS_X_LAENGE_BYTE1)			; aus SRAM laden
	LDS temp2, (adr_GPS_X_LAENGE_BYTE2)			; aus SRAM laden
	LDS temp3, (adr_GPS_X_LAENGE_BYTE3)			; aus SRAM laden
	LDS temp4, (adr_GPS_X_LAENGE_BYTE4)			; aus SRAM laden
    rcall FUNKTION_HEX_ASC_32					; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_AUSGABE_ZAHL_8_STELLEN_KURZ		; INP: TEMP1...8
	
	rcall LCD_SPACE
	rcall ANZEIGE_TEXT_AKTUELL_KURZ

	rcall LCD_ZEILE2

	LDS temp1, (adr_GPS_Y_BREITE_BYTE1)			; aus SRAM laden
	LDS temp2, (adr_GPS_Y_BREITE_BYTE2)			; aus SRAM laden
	LDS temp3, (adr_GPS_Y_BREITE_BYTE3)			; aus SRAM laden
	LDS temp4, (adr_GPS_Y_BREITE_BYTE4)			; aus SRAM laden
    rcall FUNKTION_HEX_ASC_32					; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_AUSGABE_ZAHL_8_STELLEN_KURZ		; INP: TEMP1...8

	rcall LCD_SPACE

	rcall ANZEIGE_TEXT_DEZIMAL_KURZ

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT: 	XL, low(adr_GPS_DATEN_BEREICH_BEGINN+0)								
;			XH,high(adr_GPS_DATEN_BEREICH_BEGINN+0)								
ANZEIGE_GPS_STRING:
	rcall LCD_GO_HOME
	rcall ANZEIGE_GPS_STRING_16_KURZ
	rcall LCD_ZEILE2
	rcall ANZEIGE_GPS_STRING_16_KURZ

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_GPS_STRING_16_KURZ:
	ldi temp1,16

ANZEIGE_GPS_STRING_16_KURZ_w:
	LD temp,X+
	rcall LCD_DATA
	dec temp1
	brne ANZEIGE_GPS_STRING_16_KURZ_w
	ret
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; "aktuell"																		
ANZEIGE_TEXT_AKTUELL_KURZ:
	ldi ZH, high(TEXT_AKTUELL*2)	; TEXT 
	ldi ZL, low (TEXT_AKTUELL*2)
	rcall ANZEIGE_TEXT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; "dezimal"																		
ANZEIGE_TEXT_DEZIMAL_KURZ:
	ldi ZH, high(TEXT_DEZIMAL*2)	; TEXT 
	ldi ZL, low (TEXT_DEZIMAL*2)
	rcall ANZEIGE_TEXT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_SATELLITEN:
	rcall LCD_CLEAR

	ldi ZH, high(TEXT_SATELLITEN*2)	; TEXT 
	ldi ZL, low (TEXT_SATELLITEN*2)
	rcall ANZEIGE_TEXT

	rcall LCD_ZEILE2
	rcall LCD_SPACE

	rcall FUNKTION_TEMP1_9_CLEAR 			; OUT: TEMP1...9 (alle 0)				
	LDS temp1, (adr_GPS_ANZ_SAT_GESAMT)		; aus SRAM laden
	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_FORMAT						; INPUT: TEMP1...TEMP9			 	
	rcall LCD_AUSGABE_ZAHL_2_STELLEN_KURZ

	rcall LCD_SPACE
	ldi temp, '/'
	rcall LCD_DATA
	rcall LCD_SPACE

	rcall FUNKTION_TEMP1_9_CLEAR 			; OUT: TEMP1...9 (alle 0)				
	LDS temp1, (adr_GPS_ANZ_SAT_EMPFANGEN)	; aus SRAM laden
	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_FORMAT						; INPUT: TEMP1...TEMP9			 	
	rcall LCD_AUSGABE_ZAHL_2_STELLEN_KURZ
	rcall LCD_SPACE

	rcall FUNKTION_TEMP1_9_CLEAR 			; OUT: TEMP1...9 (alle 0)				
	LDS temp1,(adr_GPS_PEGEL_SUMME_L)
	LDS temp2,(adr_GPS_PEGEL_SUMME_H)
	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_FORMAT						; INPUT: TEMP1...TEMP9			 	
	rcall LCD_AUSGABE_ZAHL_5_STELLEN_KURZ	; INP: TEMP1...5				  
	ldi temp, '%'
	rcall LCD_DATA

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_LEER_MENUE:
	rcall LCD_CLEAR
	rcall FUNKTION_TEMP1_9_CLEAR 			; OUT: TEMP1...9 (alle 0)				
	mov temp1, MENUE_0
    rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_AUSGABE_ZAHL_3_STELLEN_KURZ

	rcall LCD_SPACE

	rcall FUNKTION_TEMP1_9_CLEAR 			; OUT: TEMP1...9 (alle 0)				
	mov temp1, MENUE_1
    rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_AUSGABE_ZAHL_3_STELLEN_KURZ
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_HILFE_PLUS_TASTE:
	rcall LCD_CLEAR
	ldi ZH, high(TEXT_TASTE_PLUS*2)	; TEXT 
	ldi ZL, low (TEXT_TASTE_PLUS*2)
	rcall ANZEIGE_TEXT

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_REFERENZ_POSITIONEN_LADEN:
	rcall LCD_CLEAR

	ldi ZH, high(TEXT_REF_POSITIONEN*2)	; TEXT 
	ldi ZL, low (TEXT_REF_POSITIONEN*2)
	rcall ANZEIGE_TEXT

	rcall LCD_ZEILE2
		
	ldi ZH, high(TEXT_LADEN*2)	; TEXT 
	ldi ZL, low (TEXT_LADEN*2)
	rcall ANZEIGE_TEXT

	rcall LCD_3_PUNKT			; ...

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_REFERENZ_POSITIONEN_SPEICHERN:
	rcall LCD_CLEAR

	ldi ZH, high(TEXT_REF_POSITIONEN*2)	; TEXT 
	ldi ZL, low (TEXT_REF_POSITIONEN*2)
	rcall ANZEIGE_TEXT

	rcall LCD_ZEILE2
		
	ldi ZH, high(TEXT_SPEICHERN*2)	; TEXT 
	ldi ZL, low (TEXT_SPEICHERN*2)
	rcall ANZEIGE_TEXT

	rcall LCD_3_PUNKT				; ...

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TEXT_EDIT:
	rcall LCD_CLEAR

	ldi ZH, high(TEXT_EDIT*2)	; TEXT 
	ldi ZL, low (TEXT_EDIT*2)
	rcall ANZEIGE_TEXT

	rcall LCD_3_PUNKT			; ...
ret

; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_WAIT:
	rcall LCD_CLEAR
	ldi ZH, high(TEXT_WAIT*2)	; TEXT 
	ldi ZL,  low(TEXT_WAIT*2)
	rcall ANZEIGE_TEXT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TEXT_ERROR:
	rcall LCD_CLEAR
	ldi ZH, high(TEXT_ERROR*2)			; ERROR
	ldi ZL, low (TEXT_ERROR*2)
	rcall ANZEIGE_TEXT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT: TEMP1																	
ANZEIGE_2_STELLEN_HEX_ASC:
	clr temp2
	clr temp3
	clr temp4
 	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_AUSGABE_ZAHL_2_STELLEN_KURZ
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT: TEMP1																	
ANZEIGE_3_STELLEN_HEX_ASC:
	clr temp2
	clr temp3
	clr temp4
 	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_AUSGABE_ZAHL_3_STELLEN_KURZ
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; INPUT: TEMP1...TEMP3													  
; rcall LCD_AUSGABE_ZAHL_2_STELLEN_KURZ	; INP: TEMP1...2				  
LCD_AUSGABE_ZAHL_2_STELLEN_KURZ:
	mov temp, temp2			; 2.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	rcall LCD_DATA
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; INPUT: TEMP1...TEMP3													  
; rcall LCD_AUSGABE_ZAHL_3_STELLEN_KURZ	; INP: TEMP1...3				  
LCD_AUSGABE_ZAHL_3_STELLEN_KURZ:
	mov temp, temp3			; 3.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp2			; 2.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	rcall LCD_DATA
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; INPUT: TEMP1...TEMP4													  
; rcall LCD_AUSGABE_ZAHL_4_STELLEN_KURZ	; INP: TEMP1...4				  
LCD_AUSGABE_ZAHL_4_STELLEN_KURZ:
	mov temp, temp4			; 4.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp3			; 3.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp2			; 2.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	rcall LCD_DATA
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; INPUT: TEMP1...TEMP5													  
; rcall LCD_AUSGABE_ZAHL_5_STELLEN_KURZ	; INP: TEMP1...5				  
LCD_AUSGABE_ZAHL_5_STELLEN_KURZ:
	mov temp, temp5			; 5.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp4			; 4.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp3			; 3.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp2			; 2.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	rcall LCD_DATA
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; INPUT: TEMP1...TEMP6													  
; rcall LCD_AUSGABE_ZAHL_6_STELLEN_KURZ	; INP: TEMP1...6				  
LCD_AUSGABE_ZAHL_6_STELLEN_KURZ:
	mov temp, temp6			; 6.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp5			; 5.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp4			; 4.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp3			; 3.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp2			; 2.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	rcall LCD_DATA
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; INPUT: TEMP1...TEMP7													  
; rcall LCD_AUSGABE_ZAHL_7_STELLEN_KURZ	; INP: TEMP1...7				  
LCD_AUSGABE_ZAHL_7_STELLEN_KURZ:
	mov temp, temp7			; 7.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp6			; 6.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp5			; 5.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp4			; 4.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp3			; 3.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp2			; 2.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	rcall LCD_DATA
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; INPUT: TEMP1...TEMP8													  
; rcall LCD_AUSGABE_ZAHL_8_STELLEN_KURZ	; INP: TEMP1...9				  
LCD_AUSGABE_ZAHL_8_STELLEN_KURZ:
	mov temp, temp8			; 8.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp7			; 7.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp6			; 6.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp5			; 5.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp4			; 4.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp3			; 3.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp2			; 2.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	rcall LCD_DATA
ret
;######################################################################## 	
;######################################################################## 	
;######################################################################## 	
; formatiert die LCD AUSGABE mit 1000-er Punkt								
; 	Bsp. "00012345 => "___12.345"											
;	INPUT/Output TEMP1														
;	INPUT/Output TEMP2														
;	INPUT/Output TEMP3														
;	INPUT/Output TEMP4														
;	INPUT/Output TEMP5														
;	INPUT/Output TEMP6														
; 	INPUT/Output TEMP8														
; 	      Output TEMP9														
LCD_FORMAT:
;   1000-er Trennzeichen einfgen	
	mov temp9,temp8
	ldi temp8,'.'
	mov temp7,temp6
	mov temp6,temp5
	mov temp5,temp4
	ldi temp4,'.'
; Nullstellen-Unterdrckung			
	cpi temp9, '0'
	brne LCD_FORMAT_fertig
	ldi temp9, '_'
	ldi temp8, '_'
	cpi temp7, '0'
	brne LCD_FORMAT_fertig
	ldi temp7, '_'
	cpi temp6, '0'
	brne LCD_FORMAT_fertig
	ldi temp6, '_'
	cpi temp5, '0'
	brne LCD_FORMAT_fertig
	ldi temp5, '_'
	ldi temp4, '_'
	cpi temp3, '0'
	brne LCD_FORMAT_fertig
	ldi temp3, '_'
	cpi temp2, '0'
	brne LCD_FORMAT_fertig
	ldi temp2, '_'
	cpi temp1, '0'
	brne LCD_FORMAT_fertig
	ldi temp1, '_'
LCD_FORMAT_fertig:
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; GRAD "" Programmieren 												  
LCD_SONDERZEICHEN_PROGRAMMIEREN_0:

			ldi temp, 0b01000000	; Sonderzeichen0
			rcall lcd_command 
	
			ldi temp, 0b00000111	; Zeile8 (oberste Zeile)
			rcall LCD_DATA	
			ldi temp, 0b00000101	; Zeile7
			rcall LCD_DATA	
			ldi temp, 0b00000111	; Zeile6
			rcall LCD_DATA	
			ldi temp, 0b00000000	; Zeile5
			rcall LCD_DATA	
			ldi temp, 0b00000000	; Zeile4
			rcall LCD_DATA	
			ldi temp, 0b00000000	; Zeile3
			rcall LCD_DATA	
			ldi temp, 0b00000000	; Zeile2
			rcall LCD_DATA	
			ldi temp, 0b00000000	; Zeile1 (unterste Zeile)
			rcall LCD_DATA
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; Betriebsspannung als BALKEN											  
LCD_SONDERZEICHEN_PROGRAMMIEREN_1:
			ldi temp, 0b01001000	; Sonderzeichen1
			rcall lcd_command 

			; SPANNUNGSWERT laden und durch 100 teilen	
			LDS temp1,(adr_SPANNUNG_L)
			LDS temp2,(adr_SPANNUNG_H)
			clr temp3
			clr temp4
			ldi temp5,100
			clr temp6
			clr temp7
			clr temp8			
			rcall DIVISION_32_32	; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4	
			mov temp,temp1
 			
			ldi temp8, 0b00011111
			ldi temp7, 0b00011111
			ldi temp6, 0b00011111
			ldi temp5, 0b00011111
			ldi temp4, 0b00011111
			ldi temp3, 0b00011111
			ldi temp2, 0b00011011
			ldi temp1, 0b00011111

			cpi temp, 52										; Vergleich 			
			brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_1_FERTIG 		; gleich oder grer 	
			clr temp8											; ZEILE lschen			
			
			cpi temp, 51
			brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_1_FERTIG	
			clr temp7											; ZEILE lschen			

			cpi temp, 50
			brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_1_FERTIG	
			clr temp6											; ZEILE lschen			

			cpi temp, 49
			brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_1_FERTIG	
			clr temp5											; ZEILE lschen			

			cpi temp, 48
			brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_1_FERTIG 	
			clr temp4											; ZEILE lschen			

			cpi temp, 47
			brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_1_FERTIG	
			clr temp3											; ZEILE lschen			

			cpi temp, 46
			brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_1_FERTIG	
			clr temp2											; ZEILE lschen			

			cpi temp, 45
			brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_1_FERTIG	
			clr temp1											; ZEILE lschen			

LCD_SONDERZEICHEN_PROGRAMMIEREN_1_FERTIG:

	rcall LCD_SONDERZEICHEN_PROGRAMMIEREN_ZEILEN	; INP: TEMP1...8

ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; ANZAHL-SATELLITEN-gesamt									  			  
LCD_SONDERZEICHEN_PROGRAMMIEREN_2:

 	ldi temp, 0b01010000						; Sonderzeichen2
	rcall lcd_command 

	ldi temp8, 0b00001110
	ldi temp7, 0b00001110
	ldi temp6, 0b00001110
	ldi temp5, 0b00001110
	ldi temp4, 0b00001110
	ldi temp3, 0b00001110
	ldi temp2, 0b00001010
	ldi temp1, 0b00001110

	LDS temp,(adr_GPS_ANZ_SAT_GESAMT)				; aus SRAM laden	

	cpi temp, 8 									; vergleich			
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_2_FERTIG	; grer gleich		
	clr temp8										; ZEILE LSCHEN     
	cpi temp, 7
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_2_FERTIG
	clr temp7										; ZEILE LSCHEN     
	cpi temp, 6
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_2_FERTIG
	clr temp6										; ZEILE LSCHEN     
	cpi temp, 5
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_2_FERTIG	
	clr temp5										; ZEILE LSCHEN     
	cpi temp, 4
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_2_FERTIG 	
	clr temp4										; ZEILE LSCHEN     
	cpi temp, 3
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_2_FERTIG	
	clr temp3										; ZEILE LSCHEN     
	cpi temp, 2
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_2_FERTIG	
	clr temp2										; ZEILE LSCHEN     
	cpi temp, 1
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_2_FERTIG	
	clr temp1										; ZEILE LSCHEN     

LCD_SONDERZEICHEN_PROGRAMMIEREN_2_FERTIG:

	rcall LCD_SONDERZEICHEN_PROGRAMMIEREN_ZEILEN	; INP: TEMP1...8
		
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; ANZAHL-SATELLITEN-empfangen								  			  
LCD_SONDERZEICHEN_PROGRAMMIEREN_3:
 	ldi temp, 0b01011000	; Sonderzeichen3
	rcall lcd_command 
	
	ldi temp8, 0b00001110
	ldi temp7, 0b00001010
	ldi temp6, 0b00001110
	ldi temp5, 0b00001110
	ldi temp4, 0b00001110
	ldi temp3, 0b00001110
	ldi temp2, 0b00001010
	ldi temp1, 0b00001110

	LDS temp,(adr_GPS_ANZ_SAT_EMPFANGEN)			; aus SRAM laden	

	cpi temp, 8										; vergleich			
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_3_FERTIG 	; grer gleich		
	clr temp8										; ZEILE lschen		

	cpi temp, 7
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_3_FERTIG	
	clr temp7										; ZEILE lschen		

	cpi temp, 6
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_3_FERTIG	
	clr temp6										; ZEILE lschen		

	cpi temp, 5
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_3_FERTIG	
	clr temp5										; ZEILE lschen		

	cpi temp, 4
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_3_FERTIG 	
	clr temp4										; ZEILE lschen		

	cpi temp, 3
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_3_FERTIG	
	clr temp3										; ZEILE lschen		

	cpi temp, 2
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_3_FERTIG	
	clr temp2										; ZEILE lschen		

	cpi temp, 1
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_3_FERTIG	
	clr temp1										; ZEILE lschen		

LCD_SONDERZEICHEN_PROGRAMMIEREN_3_FERTIG:

	rcall LCD_SONDERZEICHEN_PROGRAMMIEREN_ZEILEN	; INP: TEMP1...8

ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; /h														  			  
LCD_SONDERZEICHEN_PROGRAMMIEREN_4:
 	ldi temp, 0b01100000	; Sonderzeichen4
	rcall lcd_command 

	ldi temp8, 0b00000001
	ldi temp7, 0b00000010
	ldi temp6, 0b00000100
	ldi temp5, 0b00001000
	ldi temp4, 0b00010000
	ldi temp3, 0b00000100
	ldi temp2, 0b00000111
	ldi temp1, 0b00000101



	rcall LCD_SONDERZEICHEN_PROGRAMMIEREN_ZEILEN	; INP: TEMP1...8

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; BALKEN PEGEL 																	
LCD_SONDERZEICHEN_PROGRAMMIEREN_6:
 	ldi temp, 0b01110000	; Sonderzeichen6
	rcall lcd_command 

	ldi temp8, 0b00001110
	ldi temp7, 0b00001010
	ldi temp6, 0b00001110
	ldi temp5, 0b00001110
	ldi temp4, 0b00001110
	ldi temp3, 0b00001110
	ldi temp2, 0b00001010
	ldi temp1, 0b00001110



	; ANZAHL PEGELWERTE laden		
	LDS temp,(adr_GPS_PEGEL_ANZAHL)

	cpi temp, 8										; vergleich				
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_6_FERTIG	; gleich oder grer	
	clr temp8										; ZEILE lschen			

	cpi temp, 7
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_6_FERTIG
	clr temp7										; ZEILE lschen			

	cpi temp, 6
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_6_FERTIG
	clr temp6										; ZEILE lschen			

	cpi temp, 5
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_6_FERTIG
	clr temp5										; ZEILE lschen			

	cpi temp, 4
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_6_FERTIG
	clr temp4										; ZEILE lschen			

	cpi temp, 3
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_6_FERTIG
	clr temp3										; ZEILE lschen			

	cpi temp, 2
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_6_FERTIG
	clr temp2										; ZEILE lschen			

	cpi temp, 1
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_6_FERTIG
	clr temp1										; ZEILE lschen			

LCD_SONDERZEICHEN_PROGRAMMIEREN_6_FERTIG:


	rcall LCD_SONDERZEICHEN_PROGRAMMIEREN_ZEILEN	; INP: TEMP1...8

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT: TEMP1...8																
LCD_SONDERZEICHEN_PROGRAMMIEREN_ZEILEN:
	mov temp,temp8	; Zeile8 (oberste Zeile)
	rcall LCD_DATA	
	mov temp,temp7	; Zeile7
	rcall LCD_DATA	
	mov temp,temp6	; Zeile6
	rcall LCD_DATA	
	mov temp,temp5	; Zeile5
	rcall LCD_DATA	
	mov temp,temp4	; Zeile4
	rcall LCD_DATA	
	mov temp,temp3	; Zeile3
	rcall LCD_DATA	
	mov temp,temp2	; Zeile2
	rcall LCD_DATA	
	mov temp,temp1	; Zeile1 (unterste Zeile)
	rcall LCD_DATA
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Initialisierung: muss ganz am Anfang des Programms aufgerufen werden
LCD_INIT:
 
           ldi temp, 0b00000011        ;muss 3mal hintereinander gesendet
           out LCD_PORT, temp          ;werden zur Initialisierung
           rcall lcd_enable            ;1
           rcall wait5ms
           rcall lcd_enable            ;2
           rcall wait5ms
           rcall lcd_enable            ;und 3!
           rcall wait5ms

           ldi temp, 0b00000010        ;4bit-Modus einstellen
           out LCD_PORT, temp
           rcall lcd_enable
           rcall wait5ms

           ldi temp, 0b00000001        ; DISPLAY lschen			
           rcall lcd_command
           ldi temp, 0b00001111        ; DISPLAY ein / CURSOR blinken
           rcall lcd_command
           ldi temp, 0b00000110        ; Cursor Auto-Increment
           rcall lcd_command

ret
;######################################################################## 
;######################################################################## 
;																		  
;erzeugt den Enable-Puls												  
;																		  
LCD_ENABLE:
           sbi LCD_PORT, LCD_E              ; Enable high		
 		   rcall wait50us                   ; kurze PAUSE		
		   cbi LCD_PORT, LCD_E              ; Enable low		
 		   rcall wait50us                   ; kurze PAUSE		
ret                          
;######################################################################## 
;######################################################################## 
;######################################################################## 
; sendet ein Datenbyte an das LCD										  
;																		  
; INPUT: temp															  
;																		  
; rcall LCD_DATA			; DATENBYTE an LCD inp: temp 				  
;																		  
LCD_DATA:
	push temp             	; "Sicherungskopie" 			
	push temp             	; "Sicherungskopie" 			
    swap temp               ; Vertauschen					
   	andi temp, 0b00001111   ; oberes Nibble auf Null setzen	
	out LCD_PORT,temp		; ausgeben						
    
	sbi LCD_PORT, LCD_RS 	; RS ein (high)					
	rcall lcd_enable        ; Enable-Routine aufrufen		
                         
    pop temp				; Kopie wieder laden	 		
   	andi temp, 0b00001111   ; oberes Nibble auf Null setzen	
	out LCD_PORT,temp		; ausgeben						
   
    sbi LCD_PORT, LCD_RS 	; RS ein  (high)	     		
	rcall lcd_enable        ; Enable-Routine aufrufen		
    pop temp				; Kopie wieder laden	 		
ret				                       
;######################################################################## 
;######################################################################## 
;######################################################################## 
;sendet einen Befehl an das LCD;wie lcd_data, nur ohne RS zu setzen		  
;																		  
; INPUT: temp															  
;																		  
LCD_COMMAND:                            
    push temp				; "Sicherungskopie" 			
    swap temp				; Vertauschen					
    andi temp, 0b00001111   ; oberes Nibble auf Null setzen	
	out LCD_PORT,temp		; ausgeben						

    cbi LCD_PORT, LCD_RS 	; RS aus (low)				
	rcall lcd_enable		; Enable-Routine aufrufen	
           
	pop temp				; Kopie wieder laden		
  	andi temp, 0b00001111   ; oberes Nibble auf Null setzen	
	out LCD_PORT,temp		; ausgeben						
           
	cbi LCD_PORT, LCD_RS 	; RS aus (low)       		
	rcall lcd_enable		; Enable-Routine aufrufen	
	rcall wait5ms			; Pause (wichtig)			
ret
;######################################################################## 
;########################################################################
;######################################################################## 
ANZEIGE_TEXT:
	lpm temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen	
	tst temp  			
	breq ANZEIGE_TEXT_e 	; Sprung
	rcall LCD_DATA			; Anzeige
	rjmp ANZEIGE_TEXT
	ANZEIGE_TEXT_e:
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; Display lschen														  
LCD_CLEAR:
   	ldi temp, 0b00000001
    rcall lcd_command
ret
;######################################################################## 
; KURSOR GO-HOME														  
LCD_GO_HOME:
 	ldi temp, 0b00000010
	rcall lcd_command 
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; KURSOR Sprung in ZEILE2
LCD_ZEILE2:
 			ldi temp, 0b11000000 
			rcall lcd_command 
ret
;######################################################################## 
;########################################################################
;######################################################################## 
LCD_SPACE:
	ldi temp, ' '		; SPACE
	rcall LCD_DATA	
ret
;######################################################################## 
;########################################################################
;######################################################################## 
LCD_PUNKT:
	ldi temp, '.'		; PUNKT
	rcall LCD_DATA	
ret
;######################################################################## 
;########################################################################
;######################################################################## 
LCD_3_PUNKT:
	ldi temp, '.'		; PUNKT
	rcall LCD_DATA	
	rcall LCD_DATA	
	rcall LCD_DATA	
ret
;######################################################################## 
;########################################################################
;######################################################################## 
LCD_DOPPEL_PUNKT:
	ldi temp, ':'		; DOPPELPUNKT
	rcall LCD_DATA	
ret

